// SPDX-License-Identifier: Apache-2.0
import { createMock } from "@golevelup/ts-jest";
import { ErrorMsgFixture, EvmAddressPropsFixture } from "../../../../../../../__tests__/fixtures/shared/DataFixture";
import { ErrorCode } from "../../../../../../core/error/BaseError";
import EvmAddress from "../../../../../../domain/context/contract/EvmAddress";
import { GetCouponCountQueryFixture } from "../../../../../../../__tests__/fixtures/bond/BondFixture";
import { GetCouponCountQueryHandler } from "./GetCouponCountQueryHandler";
import { GetCouponCountQueryResponse } from "./GetCouponCountQuery";
import { GetCouponCountQueryError } from "./error/GetCouponCountQueryError";
describe("GetCouponCountQueryHandler", () => {
    let handler;
    let query;
    const queryAdapterServiceMock = createMock();
    const contractServiceMock = createMock();
    const evmAddress = new EvmAddress(EvmAddressPropsFixture.create().value);
    const errorMsg = ErrorMsgFixture.create().msg;
    beforeEach(() => {
        handler = new GetCouponCountQueryHandler(queryAdapterServiceMock, contractServiceMock);
        query = GetCouponCountQueryFixture.create();
    });
    afterEach(() => {
        jest.resetAllMocks();
    });
    describe("execute", () => {
        it("throws GetCouponCountQueryError when query fails with uncaught error", async () => {
            const fakeError = new Error(errorMsg);
            contractServiceMock.getContractEvmAddress.mockRejectedValue(fakeError);
            const resultPromise = handler.execute(query);
            await expect(resultPromise).rejects.toBeInstanceOf(GetCouponCountQueryError);
            await expect(resultPromise).rejects.toMatchObject({
                message: expect.stringContaining(`An error occurred while querying coupon count: ${errorMsg}`),
                errorCode: ErrorCode.UncaughtQueryError,
            });
        });
        it("should successfully get coupon count", async () => {
            contractServiceMock.getContractEvmAddress.mockResolvedValueOnce(evmAddress);
            queryAdapterServiceMock.getCouponCount.mockResolvedValue(1);
            const result = await handler.execute(query);
            expect(result).toBeInstanceOf(GetCouponCountQueryResponse);
            expect(result.payload).toBe(1);
            expect(contractServiceMock.getContractEvmAddress).toHaveBeenCalledTimes(1);
            expect(contractServiceMock.getContractEvmAddress).toHaveBeenCalledWith(query.securityId);
            expect(queryAdapterServiceMock.getCouponCount).toHaveBeenCalledWith(evmAddress);
        });
    });
});
